package de.fhdw.wtf.common.ast.visitor;

import de.fhdw.wtf.common.ast.type.ClassModifierAbstract;
import de.fhdw.wtf.common.ast.type.ClassModifierService;
import de.fhdw.wtf.common.ast.type.ClassModifierTransient;
import de.fhdw.wtf.common.ast.type.ClassModifierVisitable;

/**
 * Visitor for {@link de.fhdw.wtf.common.ast.type.ClassModifier}.
 */
public interface ClassModifierVisitor {
	
	/**
	 * Handle operations for the type {@link ClassModifierAbstract}.
	 * 
	 * @param abstract1
	 *            {@link ClassModifierAbstract}
	 * @return Boolean
	 */
	boolean handle(ClassModifierAbstract abstract1);
	
	/**
	 * Handle operations for the type {@link ClassModifierTransient}.
	 * 
	 * @param tranzient
	 *            {@link ClassModifierTransient}
	 * @return Boolean
	 */
	boolean handle(ClassModifierTransient tranzient);
	
	/**
	 * Handle operations for the type {@link ClassModifierService}.
	 * 
	 * @param service
	 *            {@link ClassModifierService}
	 * @return Boolean
	 */
	boolean handle(ClassModifierService service);
	
	/**
	 * Handle operations for the type {@link ClassModifierVisitable}.
	 * 
	 * @param visitable
	 *            {@link ClassModifierVisitable}
	 * @return Boolean
	 */
	boolean handle(ClassModifierVisitable visitable);
}
