package de.fhdw.wtf.common.ast.visitor;

import de.fhdw.wtf.common.ast.ConstructorByTypeAndSignatureState;
import de.fhdw.wtf.common.ast.ConstructorByReferenceState;
import de.fhdw.wtf.common.ast.ConstructorInvalidState;

/**
 * Visitor for {@link de.fhdw.wtf.common.ast.ConstructorReferenceState}.
 */
public interface ConstructorReferenceStateVisitor {
	
	/**
	 * Handle operations for the type {@link ConstructorByTypeAndSignatureState}.
	 * 
	 * @param byName
	 *            {@link ConstructorByTypeAndSignatureState}
	 */
	void handle(ConstructorByTypeAndSignatureState byName);
	
	/**
	 * Handle operations for the type {@link ConstructorInvalidState}.
	 * 
	 * @param invalid
	 *            {@link ConstructorInvalidState}.
	 */
	void handle(ConstructorInvalidState invalid);
	
	/**
	 * Handle operations for the type {@link ConstructorByReferenceState}.
	 * 
	 * @param byReference
	 *            {@link ConstructorByReferenceState}.
	 */
	void handle(ConstructorByReferenceState byReference);
}
