package de.fhdw.wtf.common.ast.visitor;

import de.fhdw.wtf.common.ast.ConstructorByTypeAndSignatureState;
import de.fhdw.wtf.common.ast.ConstructorByReferenceState;
import de.fhdw.wtf.common.ast.ConstructorInvalidState;

/**
 * Exception Visitor for {@link de.fhdw.wtf.common.ast.ConstructorReferenceState}.
 * 
 * @param <Y>
 *            ExceptionType
 */
public interface ConstructorReferenceStateVisitorException<Y extends Exception> {
	
	/**
	 * Handle operations for the type {@link ConstructorByTypeAndSignatureState}.
	 * 
	 * @param byName
	 *            {@link ConstructorByTypeAndSignatureState}
	 * @throws Y
	 *             Y
	 */
	void handle(ConstructorByTypeAndSignatureState byName) throws Y;
	
	/**
	 * Handle operations for the type {@link ConstructorInvalidState}.
	 * 
	 * @param invalid
	 *            {@link ConstructorInvalidState}.
	 * @throws Y
	 *             Y
	 */
	void handle(ConstructorInvalidState invalid) throws Y;
	
	/**
	 * Handle operations for the type {@link ConstructorByReferenceState}.
	 * 
	 * @param byReference
	 *            {@link ConstructorByReferenceState}.
	 * @throws Y
	 *             Y
	 */
	void handle(ConstructorByReferenceState byReference) throws Y;
}
