package de.fhdw.wtf.common.ast.visitor;

import de.fhdw.wtf.common.ast.Group;
import de.fhdw.wtf.common.ast.type.ClassType;

/**
 * Exception-Visitor for {@link de.fhdw.wtf.common.ast.GroupElement}.
 * 
 * @param <X>
 *            ExceptionType
 */
public interface GroupElementExceptionVisitor<X extends Exception> {
	
	/**
	 * Handle-Method.
	 * 
	 * @param g
	 *            {@link Group}
	 * @throws X
	 *             X
	 */
	void handle(Group g) throws X;
	
	/**
	 * Handle-Method.
	 * 
	 * @param clss
	 *            {@link ClassType}
	 * @throws X
	 *             X
	 */
	void handle(ClassType clss) throws X;
}
