package de.fhdw.wtf.common.ast.visitor;

import de.fhdw.wtf.common.ast.QualifiedName;
import de.fhdw.wtf.common.ast.UnqualifiedName;
import de.fhdw.wtf.common.exception.referencer.InvalidTypeReferenceException;

/**
 * Visitor for {@link de.fhdw.wtf.common.ast.Name}.
 */
public interface NameVisitor {
	
	/**
	 * Handle-method for a {@link de.fhdw.wtf.common.ast.UnqualifiedName}.
	 * 
	 * @param name
	 *            : {@link UnqualifiedName}.
	 * @throws InvalidTypeReferenceException
	 *             InvalidTypeReferenceException
	 */
	void handle(UnqualifiedName name) throws InvalidTypeReferenceException;
	
	/**
	 * Handle-method for a {@link de.fhdw.wtf.common.ast.QualifiedName}.
	 * 
	 * @param name
	 *            : {@link QualifiedName}.
	 * @throws InvalidTypeReferenceException
	 *             InvalidTypeReferenceException
	 */
	void handle(QualifiedName name) throws InvalidTypeReferenceException;
}
