package de.fhdw.wtf.common.ast.visitor;

import de.fhdw.wtf.common.ast.type.AtomicType;
import de.fhdw.wtf.common.ast.type.CompositeType;
import de.fhdw.wtf.common.ast.type.TypeProxy;

/**
 * Return-Exception-Visitor for {@link de.fhdw.wtf.common.ast.type.Type}.
 * 
 * @param <X>
 *            ReturnType
 * @param <Y>
 *            ExceptionType
 */
public interface TypeVisitorReturnException<X, Y extends Exception> {
	
	/**
	 * Handle-Method.
	 * 
	 * @param atomicType
	 *            {@link AtomicType}
	 * @return X
	 * @throws Y
	 *             Y
	 */
	X handle(AtomicType atomicType) throws Y;
	
	/**
	 * Handle-Method.
	 * 
	 * @param compositeType
	 *            {@link CompositeType}
	 * @return X
	 * @throws Y
	 *             Y
	 */
	X handle(CompositeType compositeType) throws Y;
	
	/**
	 * Handle-Method.
	 * 
	 * @param typeProxy
	 *            {@link TypeProxy}
	 * @return X
	 * @throws Y
	 *             Y
	 */
	X handle(TypeProxy typeProxy) throws Y;
}
