package de.fhdw.wtf.common.exception.editor;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

//TODO Fehlermeldung verbessern! Es werden teilweise null Objekte als Gründe eingefügt. Es existiert keine Textmeldung über den Fehler!
public class MultipleCheckExceptions extends Exception {
	
	/**
	 * generated.
	 */
	private static final long serialVersionUID = 3581469331906103808L;
	
	/**
	 * Collection of {@link CheckException}s.
	 */
	private final Collection<CheckException> exc;
	
	/**
	 * Constructor of {@link MultipleCheckExceptions}.
	 * 
	 * @param exc
	 *            Collection of {@link CheckException}s
	 */
	public MultipleCheckExceptions(final Collection<CheckException> exc) {
		this.exc = exc;
	}
	
	/**
	 * Constructor of {@link MultipleCheckExceptions}.
	 * 
	 * @param exc
	 *            {@link CheckException}
	 */
	public MultipleCheckExceptions(final CheckException exc) {
		this(new ArrayList<CheckException>());
		this.getExc().add(exc);
	}
	
	/**
	 * Constructor of {@link MultipleCheckExceptions}.
	 * 
	 */
	public MultipleCheckExceptions() {
		this(new ArrayList<CheckException>());
	}
	
	/**
	 * Returns the Collection of {@link CheckException}s.
	 * 
	 * @return exceptions
	 */
	private Collection<CheckException> getExc() {
		return this.exc;
	}
	
	/**
	 * Add a {@link CheckException}.
	 * 
	 * @param c
	 *            checkException
	 */
	public void add(final CheckException c) {
		this.getExc().add(c);
	}
	
	/**
	 * Returns true, if the collection of {@link CheckException}s is empty. Otherwise false.
	 * 
	 * @return isEmpty
	 */
	public boolean isEmpty() {
		return this.getExc().isEmpty();
	}
	
	/**
	 * Returns a iterator of the collection of {@link CheckException}s.
	 * 
	 * @return iterator for exceptions
	 */
	public Iterator<CheckException> iterator() {
		return this.getExc().iterator();
	}
	
	/**
	 * Returns the count of collected exceptions.
	 * 
	 * @return count of exceptions
	 */
	public int getExeptionCount() {
		return this.exc.size();
	}
}
