package de.fhdw.wtf.common.exception.parser;

import de.fhdw.wtf.common.constants.parser.ExceptionConstants;
import de.fhdw.wtf.common.token.Token;

/**
 * {@link AttributeModifierAlreadyAddedException} will be thrown, if an {@link de.fhdw.wtf.common.ast.AttributeModifier}
 * add to the list of modifiers and the modifier already exists in the list.
 * 
 */
public class AttributeModifierAlreadyAddedException extends AbstractParserException {
	
	/**
	 * generated.
	 */
	private static final long serialVersionUID = 4659040316991811697L;
	
	/**
	 * Constructor of {@link AttributeModifierAlreadyAddedException}.
	 * 
	 * @param token
	 *            token
	 * @param message
	 *            message
	 */
	protected AttributeModifierAlreadyAddedException(final Token token, final String message) {
		super(token, message);
	}
	
	/**
	 * Creates a {@link AttributeModifierAlreadyAddedException}-Object.
	 * 
	 * @param token
	 *            token
	 * @return The {@link AttributeModifierAlreadyAddedException}-Object.
	 */
	public static AttributeModifierAlreadyAddedException create(final Token token) {
		return new AttributeModifierAlreadyAddedException(token,
				ExceptionConstants.ATTRIBUTE_MODIFIER_ALREADY_ADDED_EXCEPTION);
	}
}
