package de.fhdw.wtf.common.exception.parser;

import de.fhdw.wtf.common.token.Token;

/**
 * The {@link NoBracketCloseException} will be thrown if a {@link de.fhdw.wtf.common.token.symbols.BracketCloseToken} is
 * expected, but an another Token was found.
 * 
 */
public final class NoBracketCloseException extends AbstractParserException {
	
	/**
	 * generated.
	 */
	private static final long serialVersionUID = -5285157902168385536L;
	
	/**
	 * Constructor of {@link NoBracketCloseException}.
	 * 
	 * @param token
	 *            token
	 * @param message
	 *            message
	 */
	private NoBracketCloseException(final Token token, final String message) {
		super(token, message);
	}
	
	/**
	 * Creates a {@link NoBracketCloseException}-Object.
	 * 
	 * @param token
	 *            token
	 * @return The {@link NoBracketCloseException}-Object.
	 */
	public static NoBracketCloseException create(final Token token) {
		return new NoBracketCloseException(token,
				de.fhdw.wtf.common.constants.parser.ExceptionConstants.NO_BRACKET_CLOSE_EXCEPTION_MESSAGE);
	}
	
}
