package de.fhdw.wtf.common.exception.parser;

import de.fhdw.wtf.common.token.Token;

/**
 * The {@link NoPlusSymbolException} will be thrown if a {@link de.fhdw.wtf.common.token.symbols.PlusSymbolToken} is
 * expected, but an another Token was found.
 * 
 */
public final class NoPlusSymbolException extends AbstractParserException {
	
	/**
	 * generated.
	 */
	private static final long serialVersionUID = 8032397625301746187L;
	
	/**
	 * Constructor of {@link NoPlusSymbolException}.
	 * 
	 * @param token
	 *            token
	 * @param message
	 *            message
	 */
	private NoPlusSymbolException(final Token token, final String message) {
		super(token, message);
	}
	
	/**
	 * Creates a {@link NoPlusSymbolException}-Object.
	 * 
	 * @param token
	 *            token
	 * @return The {@link NoPlusSymbolException}-Object.
	 */
	public static NoPlusSymbolException create(final Token token) {
		return new NoPlusSymbolException(token,
				de.fhdw.wtf.common.constants.parser.ExceptionConstants.NO_PLUS_SYMBOL_EXCEPTION_MESSAGE);
	}
}
