package de.fhdw.wtf.dsl.scanner.common;

import de.fhdw.wtf.common.token.Position;

/**
 * Reresents a loop in the {@link Scanner} automata. Where the current {@link ScannerState} object is also the next
 * {@link ScannerState}.
 * 
 * @see Delta
 */
public class LoopDelta extends Delta {
	
	public LoopDelta(final StateMatcher fromStateMatcher, final InputMatcher inputMatcher) {
		super(fromStateMatcher, inputMatcher);
	}
	
	@Override
	public ScannerState getNextScannerState(final Position position, final ScannerState currentState) {
		return currentState;
	}
	
	/**
	 * Factory-Method für {@link LoopDelta}.
	 * 
	 * @param fromStateMatcher
	 *            : originalState
	 * @param inputMatcher
	 * @return new {@link LoopDelta}
	 */
	public static LoopDelta create(final StateMatcher fromStateMatcher, final InputMatcher inputMatcher) {
		return new LoopDelta(fromStateMatcher, inputMatcher);
	}
	
}
